/*
 Copyright 2012, S.S. Papadopulos & Assoc. Inc.

    This file is part of GENIE.

    The GENIE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    GENIE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GENIE.  If not, see<http://www.gnu.org/licenses/>.
*/

// cmuffels, Genie version 1, 2012

#ifndef CONNECTOR_H
#define CONNECTOR_H

#include <list>

#include "thread.h"
#include "host.h"
#include "client.h"

//****************************************************************************
class CONNECTOR : public THREAD
//****************************************************************************
//CTM Mar 2011

/*
      Thread class to accept incoming connection requests
*/

{

  public:

      int execute();
      void set_host(HOST *_host);
      void set_queue_slaves(std::list<CLIENT*> *_slaves);

  private:

      HOST *host;
      CLIENT *slave;
      std::list<CLIENT*> *slaves;

};

#endif // CONNECTOR_H
