/*
 Copyright 2012, S.S. Papadopulos & Assoc. Inc.

    This file is part of GENIE.

    The GENIE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    GENIE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GENIE.  If not, see<http://www.gnu.org/licenses/>.
*/

// cmuffels, Genie version 1, 2012

#include "restart.h"

using namespace std;

//****************************************************************************
bool RESTART::open_me(string filename)
//****************************************************************************
//CTM May 2011

/*
      Open restart file
*/

{

  // open the restart file
  file.open(filename.c_str(),fstream::in|fstream::binary);
  if(!file.is_open())
  {
    // file does not exist - open for out, close and then open for out/in
    file.open(filename.c_str(),fstream::out|fstream::binary);
    file.close();
  }
  else
    file.close();
  file.clear();
  file.open(filename.c_str(),fstream::in|fstream::out|fstream::binary);

  //
  //// check if file i/o is good
  //if(file.is_open())
  //{
  //  if(!file.good())
  //  {
  //    cout<<"EOF: "<<file.eof()<<'\n';
  //    cout<<"BAD: "<<file.bad()<<'\n';
  //    cout<<"FAIL: "<<file.fail()<<'\n';
  //  }
  //}

  return file.is_open();

}

//****************************************************************************
bool RESTART::close_me()
//****************************************************************************
//CTM May 2011

/*
      Close restart file
*/

{

  file.close();

  return true;


}

//****************************************************************************
int RESTART::put_run(MODEL_RUN *run)
//****************************************************************************
//CTM May 2011

/*
      Add run to binary restart file
*/

{

  // verify the file can be written to
  if(!file.good())
    return 0;
  else
  {
    run->save(file);
    file.flush();
    return 1;
  }

}
