/*
 Copyright 2012, S.S. Papadopulos & Assoc. Inc.

    This file is part of GENIE.

    The GENIE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    GENIE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GENIE.  If not, see<http://www.gnu.org/licenses/>.
*/

// cmuffels, Genie version 1, 2012

#ifndef RUNMANAGER_H
#define RUNMANAGER_H

#include <list>
#include <set>
#include <map>

#include "receivor.h"
#include "managedrun.h"
#include "modelrun.h"
#include "modelresult.h"

//****************************************************************************
class RUN_MANAGER
//****************************************************************************
{

  public:

    void initialize();
    void add_new_run(MODEL_RUN *_run);
    void add_new_client(CLIENT *_slave);
    void start_waiting_runs();
    void check_client_status(std::map<CLIENT*,bool> &_slaveconnected);
    void check_run_status();
    void terminate_clients();

  private:


    HANDLE h_thComm;
    HANDLE m_thRuns;

    //std::list<RECEIVOR*> *threads;
    std::list<MANAGED_RUN*> *runs_todo;
    std::list<MANAGED_RUN*> *runs_inprogress;
    std::multiset<CLIENT*,cmp_speed> *clients_waiting;
    std::multiset<CLIENT*,cmp_speed> *clients_working;

};

#endif /* RUNMANAGER_H */
