/*
 Copyright 2012, S.S. Papadopulos & Assoc. Inc.

    This file is part of GENIE.

    The GENIE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    GENIE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GENIE.  If not, see<http://www.gnu.org/licenses/>.
*/

// cmuffels, Genie version 1, 2012

#ifndef SENDOR_H
#define SENDOR_H

#include <list>
#include "thread.h"
#include "client.h"
#include "modelresult.h"

//****************************************************************************
class SENDOR : public THREAD
//****************************************************************************
//CTM Apr 2011

/*
      Thread class to send completed runs to calling program
*/

{

  public:

      int execute();
      void set_calling_program(CLIENT *_model);
      void set_queue_results(std::list<MODEL_RESULT*> *_results);

  private:

      CLIENT *model;
      std::list<MODEL_RESULT*> *results;

};

#endif // SENDOR_H
