/*
 Copyright 2012, S.S. Papadopulos & Assoc. Inc.

    This file is part of GENIE.

    The GENIE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    GENIE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GENIE.  If not, see<http://www.gnu.org/licenses/>.
*/

// cmuffels, Genie version 1, 2012

#ifndef TERMINATOR_H
#define TERMINATOR_H

#include <list>
#include "thread.h"
#include "receivor.h"

//****************************************************************************
class TERMINATOR : public THREAD
//****************************************************************************
//CTM Apr 2011

/*
      Thread class to terminate threads associated with disconnected slaves
*/

{

  public:

      int execute();
      void set_threads_end(std::list<RECEIVOR*> _threads_end);
      void set_handles_end(std::list<HANDLE> _handles_end);
      //void set_primary_thread_handle(HANDLE _primary);

  private:

      //HANDLE primary;
      std::list<RECEIVOR*> threads_end;
      std::list<HANDLE> handles_end;


};

#endif // TERMINATOR_H
